#ifndef _Horner_h
#define _Horner_h

#include <initializer_list>
#include <unordered_map>

class Polynomial { // Polynomial evaluation according to different methods...
private:
	std::unordered_map<unsigned, double> _polynomial;
public:
	Polynomial(unsigned = 5U); // https://en.cppreference.com/w/cpp/language/integer_literal
	Polynomial(const std::initializer_list<std::unordered_map<unsigned, double>::value_type>&);
	double horner_method(double, bool parallel = false) const;
	double simple_method(double) const;
	std::string to_string() const;
};

#endif
